package Main;

import Pieces.*;

import java.util.ArrayList;
import java.util.Queue;

public class Board {
    private Piece board[][] = new Piece[8][8];
    public Board(){
        board[0][0] = new Rook(0,0,false,this);
        board[7][0] = new Rook(7,0,false,this);
        board[1][0] = new Knight(1,0,false,this);
        board[6][0] = new Knight(6,0,false,this);
        board[2][0] = new Bishop(2,0,false,this);
        board[5][0] = new Bishop(5,0,false,this);
        board[3][0] = new King(3,0,false,this);
        board[4][0] = new Queen(4,0,false,this);


        for (int i = 0 ; i < 8 ; i++){
            board[i][1] = new Pawn(i,1,false,this);
            board[i][6] = new Pawn(i,6,true,this);
        }

        board[0][7] = new Rook(0,7,true,this);
        board[7][7] = new Rook(7,7,true,this);
        board[1][7] = new Knight(1,7,true,this);
        board[6][7] = new Knight(6,7,true,this);
        board[2][7] = new Bishop(2,7,true,this);
        board[5][7] = new Bishop(5,7,true,this);
        board[3][7] = new Queen(3,7,true,this);
        board[4][7] = new King(4,7,true,this);

    }
    public boolean getMove(int x , int y , int destX , int destY){
        if(board[x][y]==null) return false;
//        System.out.println(x+","+y+"->"+destX+","+destY);
//        System.out.println(board[x][y]);
        if (board[x][y].isValidMove(destX,destY)){
//            System.out.println("Reach");
            board[x][y].setX(destX);
            board[x][y].setY(destY);
            board[destX][destY] = getCopy(board[x][y]);
            board[x][y] = null;
            return true;
        }
        else return false;
    }
    public ArrayList<int[]> getMoves(int x,int y){
        if(board[x][y]==null) return new ArrayList<>();
        return board[x][y].moves();
    }
    public Piece getCopy(Piece p){
        if(p instanceof Bishop){
            Bishop ret = new Bishop(p.getX(),p.getY(),p.isWhite(),p.getBoard());
            return ret;
        }else if(p instanceof King){
            King ret = new King(p.getX(),p.getY(),p.isWhite(),p.getBoard());
            return ret;
        }
        else if(p instanceof Knight){
            Knight ret = new Knight(p.getX(),p.getY(),p.isWhite(),p.getBoard());
            return ret;
        }else if(p instanceof Pawn){
            Pawn ret = new Pawn(p.getX(),p.getY(),p.isWhite(),p.getBoard());
            return ret;
        }else if(p instanceof Queen){
            Queen ret = new Queen(p.getX(),p.getY(),p.isWhite(),p.getBoard());
            return ret;
        }
        else {
            Rook ret = new Rook(p.getX(),p.getY(),p.isWhite(),p.getBoard());
            return ret;
        }
    }
    public Piece[][] getBoard() {
        return board;
    }
    public boolean isEmpty(int x , int y){
        if (board[x][y] ==null) return true;
        return false;
    }
    public int getColor(int x , int y){
        if(isEmpty(x, y)) return 0;
        if (board[x][y].isWhite()) return 1;
        if (board[x][y].isBlack()) return 2;

        return 0;
    }

    @Override
    public String toString() {
        String str = "";
        for (int j = 0 ; j < 8 ; j++){
            for (int i = 0 ; i < 7 ; i++){
                if(board[i][j]!=null) {
                    str = str + board[i][j] + " ";
                }
                else
                    str = str + "0 ";
            }
            if(board[7][j]!=null) {
                str = str + board[7][j] + "\n";
            }
            else
                str = str + "0\n";
        }
        return str;
    }
}
