package Pieces;

import Main.Board;
import Main.Cell;

import java.util.ArrayList;
import java.util.HashSet;

public class King extends Piece {


    public King(int x, int y, boolean isWhite, Board board) {
        super(x, y, isWhite, board);
    }

    @Override
    public boolean isCanMove(int dx, int dy) {
        if (isOutside(dx, dy)) return false;
        int deltaX = Math.abs(dx-getX());
        int deltaY = Math.abs(dy-getY());
        if( deltaX==deltaY && deltaX ==1) return true;
        if(deltaX ==1 && deltaY ==0) return true;
        if(deltaX==0 && deltaY ==1) return true;
        return false;
    }

    @Override
    public boolean isValidMove(int dx, int dy) {
//        if(!isCanMove(dx, dy)) return false;
//        for(int i = Math.min(dx,getX());i< Math.max(dx,getX());i++){
//            for(int j =Math.min(dy,getY());i < Math.max(dy,getY());j++){
//                if(getBoard().getBoard()[i][j]!=null) return false;
//            }
//        }
        ArrayList<int[]> moves = moves();
        for (int m[] : moves){
            if(m[0]==dx && m[1] == dy){
                return true;
//                break;
            }
        }
        return false;
    }

    public HashSet<Cell> getThreatedPlaces(){
        HashSet<Cell> retSet = new HashSet<>();
        for (int i = 0 ; i < 8 ; i++){
            for(int j =0 ; j < 8 ; j++){
                Piece p = getBoard().getBoard()[i][j];
                if(p!=null && (p.isWhite()!=isWhite())){
                    ArrayList<int[]> moves = p.moves();
                    for(int m[] : moves){
                        Cell c = new Cell(m[0],m[1]);
                        retSet.add(c);
                    }
                }
            }
        }
        return retSet;
    }
    @Override
    public ArrayList<int[]> moves() {
        ArrayList<int[]> move = new ArrayList<>();
        HashSet<Cell> threats = getThreatedPlaces();
        int x = getX();
        int y = getY();
        int posx[]={x,x,x+1,x+1,x+1,x-1,x-1,x-1};
        int posy[]={y-1,y+1,y-1,y,y+1,y-1,y,y+1};
        for(int i=0;i<8;i++){
            if((posx[i]>=0&&posx[i]<8&&posy[i]>=0&&posy[i]<8)){
                if(getBoard().isEmpty(posx[i],posy[i]) || (getBoard().getColor(posx[i],posy[i])==2 && this.isWhite()) ||(getBoard().getColor(posx[i],posy[i])==1 && isBlack()) )
                {
                    Cell cmp = new Cell(posx[i],posy[i]);
                    if(!threats.contains(cmp)) {
                        move.add(new int[]{posx[i], posy[i]});
                    }
                }
            }
        }
        return move;
    }

    @Override
    public String toString() {
        return "K";
    }
}
